
//// Ukazka jednorazoveho nacteni dat - jak zakladni, tak pripadne i rozsirene promenne

PROGRAM prgMain
  VAR CONSTANT
    IP_Address : STRING := '192.168.1.125:502';
    chanCode : UINT := ETH1_uni0;
    tcp : BOOL := true;
    
    INVERTER_COUNT  : USINT  := 4;      (* maximalni pocet zarizeni typu Inverter  *)
    STRINGBOX_COUNT : USINT  := 2;      (* maximalni pocet zarizeni typu StringBox *)
    BATTERY_COUNT   : USINT  := 2;      (* maximalni pocet zarizeni typu Battery   *)
    METER_COUNT     : USINT  := 3;      (* maximalni pocet zarizeni typu Meter     *)
    DEVICE_COUNT    : USINT := INVERTER_COUNT + STRINGBOX_COUNT + BATTERY_COUNT + METER_COUNT;
  END_VAR

  VAR
    DeviceInfo : ARRAY [1 .. DEVICE_COUNT] OF TDeviceBlockInfo;
    Inverter  : ARRAY [1 .. INVERTER_COUNT] OF TInverter;
    StringBox : ARRAY [1 .. STRINGBOX_COUNT]OF TStringBox;
    Battery   : ARRAY [1 .. BATTERY_COUNT]  OF TBattery;
    Meter     : ARRAY [1 .. METER_COUNT]    OF TMeter;
    DeviceMiB :  ARRAY [1 .. DEVICE_COUNT] OF TDeviceMiB;

    smInit_enable : BOOL := true;
    sm_enable : BOOL;
    smMiB_enable : BOOL;

    smInit : fb_SMInit;
    sm : fb_SMReadData;
    smMiB :fb_SMReadStuderMiBData;
    smFini : fb_SMFini;
  END_VAR

  // pocatecni detekce pritomnych zarizeni
  smInit(enable := smInit_enable, ip := IP_Address, tcp := tcp, chanCode := chanCode, DevInfoPtr := ADR(DeviceInfo), DevInfoSize := DEVICE_COUNT, InverterPtr := ADR(Inverter), InverterCount := INVERTER_COUNT, StringBoxPtr := ADR(StringBox), StringBoxCount := STRINGBOX_COUNT, BatteryPtr := ADR(Battery), BatteryCount := BATTERY_COUNT, MeterPtr := ADR(Meter), MeterCount := METER_COUNT);


  IF smInit.done THEN
    smInit_enable := false;
    sm_enable := true;
  END_IF;

  //nacteni zakladnich promennych
  sm(enable := sm_enable, ip := IP_Address, chanCode := chanCode, tcp := tcp, DevInfoPtr := ADR(DeviceInfo), devCount:= smInit.devCount);

  IF sm.done OR sm.err THEN
    sm_enable := false;
    smMiB_enable := true;
  END_IF;

  //nacteni rozsirenych promennych (provede se pouze pro Studer-Innotec zarizeni)
  smMiB(enable := smMiB_enable, ip := IP_Address, chanCode := chanCode, tcp := tcp, DevInfoPtr := ADR(DeviceInfo), DevMiBPtr := ADR(DeviceMiB), devCount:= smInit.devCount);

  IF smMiB.done OR smMiB.err THEN
    smMiB_enable := false;
    smFini(tcp := tcp);
  END_IF;

END_PROGRAM


