PROGRAM prgMain
  VAR CONSTANT
    IP_Address      : STRING := '192.168.1.193:502';
    chanCode        : UINT   := ETH1_uni0;
    tcp             : BOOL   := true;
    INVERTER_COUNT  : USINT  := 4;      (* maximalni pocet zarizeni typu Inverter *)
    STRINGBOX_COUNT : USINT  := 2;      (* maximalni pocet zarizeni typu StringBox*)
    BATTERY_COUNT   : USINT  := 2;      (* maximalni pocet zarizeni typu Battery*)
    METER_COUNT     : USINT  := 3;      (* maximalni pocet zarizeni typu Meter*)
    DEVICE_COUNT    : USINT  := INVERTER_COUNT + STRINGBOX_COUNT + BATTERY_COUNT + METER_COUNT;
    PERIOD_TIME     : TIME   := T#10s;
  END_VAR

  VAR_INPUT
  END_VAR
  VAR_OUTPUT
  END_VAR
  VAR
    smInit : fb_SMInit;
    sm : fb_SMReadData;
    DeviceInfo : ARRAY [1..DEVICE_COUNT]    OF TDeviceBlockInfo; (*Informace o blocich v jednotlivych zarizenich*)
    Inverter   : ARRAY [1..INVERTER_COUNT]  OF TInverter;
    StringBox  : ARRAY [1..STRINGBOX_COUNT] OF TStringBox;
    Battery    : ARRAY [1..BATTERY_COUNT]   OF TBattery;
    Meter      : ARRAY [1..METER_COUNT]     OF TMeter;
    DeviceTypeCount : TDeviceTypeCount;
    smMiB : fb_SMReadStuderMiBData;
    DeviceMiB : ARRAY [1..DEVICE_COUNT] OF TDeviceMiB; (*Rozsirene promenne (specificke, detailnejsi)*)
    timer : TON;
    state : USINT; //stav automatu
    next_state : USINT;
    timer_ET : TIME;
  END_VAR
  VAR_TEMP
  END_VAR
{NOCODE}
<?xml version="1.0" encoding="windows-1250" ?>
<?xml-stylesheet type="text/xsl" href="pokus.xsl" version="1.1"?>
<fbd version="1.1">
<comment id="1" height="3" width="12">
  <position x="3" y="5" />
Schema comment
</comment>
<block name="fb_SMReadData" instance="sm" id="2" height="14" width="14" line="30" order="7">
  <position x="106" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="35" name="EQ">
        <position x="106" y="15" />
        <position x="101" y="15" />
        <position x="101" y="13" />
        <position x="100" y="13" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="31">
        <position x="106" y="17" />
        <position x="96" y="17" />
        <position x="96" y="17" />
        <position x="88" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="32">
        <position x="106" y="19" />
        <position x="94" y="19" />
        <position x="94" y="19" />
        <position x="87" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="33">
        <position x="106" y="21" />
        <position x="93" y="21" />
        <position x="93" y="21" />
        <position x="86" y="21" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="22">
        <position x="106" y="23" />
        <position x="104" y="23" />
        <position x="104" y="23" />
        <position x="103" y="23" />
      </connection>
    <comment>pointer to array of blocks obtained with fb_ReadDeviceInfo</comment>
    </variable>
    <variable name="devCount" type="USINT">
      <connection refid="58">
        <position x="106" y="25" />
        <position x="94" y="25" />
        <position x="94" y="25" />
        <position x="78" y="25" />
      </connection>
    <comment>number of detected devices</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
  </outVariables>
</block>
<block name="TON" instance="timer" id="3" height="6" width="6" line="58" order="15">
  <position x="110" y="52" />
  <inVariables>
    <variable name="IN" type="BOOL">
      <connection refid="38" name="EQ">
        <position x="110" y="55" />
        <position x="101" y="55" />
        <position x="101" y="53" />
        <position x="100" y="53" />
      </connection>
    <comment>input</comment>
    </variable>
    <variable name="PT" type="TIME">
      <connection refid="5">
        <position x="110" y="57" />
        <position x="62" y="57" />
        <position x="62" y="57" />
        <position x="12" y="57" />
      </connection>
    <comment>preset</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q" type="BOOL">
    <comment>output</comment>
    </variable>
    <variable name="ET" type="TIME">
    <comment>value</comment>
    </variable>
  </outVariables>
</block>
<outVariable name="timer_ET" type="TIME" id="4" order="16">
  <position x="140" y="61" />
  <connection refid="3" name="ET">
    <position x="141" y="62" />
    <position x="125" y="62" />
    <position x="125" y="57" />
    <position x="116" y="57" />
  </connection>
</outVariable>
<inVariable name="PERIOD_TIME" type="TIME" id="5">
  <position x="1" y="56" />
</inVariable>
<block name="fb_SMInit" instance="smInit" id="6" height="30" width="20" line="12" order="2">
  <position x="41" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="30" name="EQ">
        <position x="41" y="15" />
        <position x="40" y="15" />
        <position x="40" y="13" />
        <position x="28" y="13" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="23">
        <position x="41" y="17" />
        <position x="34" y="17" />
        <position x="34" y="17" />
        <position x="33" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="25">
        <position x="41" y="19" />
        <position x="36" y="19" />
        <position x="36" y="19" />
        <position x="35" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="24">
        <position x="41" y="21" />
        <position x="38" y="21" />
        <position x="38" y="21" />
        <position x="37" y="21" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="21">
        <position x="41" y="23" />
        <position x="21" y="23" />
        <position x="21" y="27" />
        <position x="14" y="27" />
      </connection>
    <comment>pointer to array start</comment>
    </variable>
    <variable name="DevInfoSize" type="USINT">
      <connection refid="11">
        <position x="41" y="25" />
        <position x="23" y="25" />
        <position x="23" y="30" />
        <position x="14" y="30" />
      </connection>
    <comment>max. number of devices (array size)</comment>
    </variable>
    <variable name="InverterPtr" type="PTR_TO TInverter">
      <connection refid="12">
        <position x="41" y="27" />
        <position x="25" y="27" />
        <position x="25" y="33" />
        <position x="12" y="33" />
      </connection>
    <comment>Pointer to array of Inverter structures</comment>
    </variable>
    <variable name="InverterCount" type="USINT">
      <connection refid="16">
        <position x="41" y="29" />
        <position x="27" y="29" />
        <position x="27" y="36" />
        <position x="15" y="36" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="StringBoxPtr" type="PTR_TO TStringBox">
      <connection refid="13">
        <position x="41" y="31" />
        <position x="29" y="31" />
        <position x="29" y="39" />
        <position x="13" y="39" />
      </connection>
    <comment>Pointer to array of StringBox structures</comment>
    </variable>
    <variable name="StringBoxCount" type="USINT">
      <connection refid="17">
        <position x="41" y="33" />
        <position x="31" y="33" />
        <position x="31" y="42" />
        <position x="17" y="42" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="BatteryPtr" type="PTR_TO TBattery">
      <connection refid="14">
        <position x="41" y="35" />
        <position x="33" y="35" />
        <position x="33" y="45" />
        <position x="12" y="45" />
      </connection>
    <comment>Pointer to array of Battery structures</comment>
    </variable>
    <variable name="BatteryCount" type="USINT">
      <connection refid="18">
        <position x="41" y="37" />
        <position x="35" y="37" />
        <position x="35" y="48" />
        <position x="15" y="48" />
      </connection>
    <comment>max. number of Batteries (array size)</comment>
    </variable>
    <variable name="MeterPtr" type="PTR_TO TMeter">
      <connection refid="15">
        <position x="41" y="39" />
        <position x="37" y="39" />
        <position x="37" y="51" />
        <position x="11" y="51" />
      </connection>
    <comment>Pointer to array of Meter structures</comment>
    </variable>
    <variable name="MeterCount" type="USINT">
      <connection refid="19">
        <position x="41" y="41" />
        <position x="39" y="41" />
        <position x="39" y="54" />
        <position x="13" y="54" />
      </connection>
    <comment>max. number of Meters (array size)</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
    <variable name="devCount" type="USINT">
    <comment>number of devices in the SM2-MU gateway</comment>
    </variable>
    <variable name="DevTypeCount" type="TDeviceTypeCount">
    <comment>structure with count of each device type</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="0" type="" id="7">
  <position x="20" y="14" />
</inVariable>
<inVariable name="IP_Address" type="STRING" id="8">
  <position x="1" y="17" />
</inVariable>
<inVariable name="chanCode" type="UINT" id="9">
  <position x="1" y="20" />
</inVariable>
<inVariable name="tcp" type="BOOL" id="10">
  <position x="1" y="23" />
</inVariable>
<inVariable name="DEVICE_COUNT" type="USINT" id="11">
  <position x="1" y="29" />
</inVariable>
<inVariable name="ADR(Inverter)" type="" id="12">
  <position x="0" y="32" />
</inVariable>
<inVariable name="ADR(StringBox)" type="" id="13">
  <position x="1" y="38" />
</inVariable>
<inVariable name="ADR(Battery)" type="" id="14">
  <position x="1" y="44" />
</inVariable>
<inVariable name="ADR(Meter)" type="" id="15">
  <position x="1" y="50" />
</inVariable>
<inVariable name="INVERTER_COUNT" type="USINT" id="16">
  <position x="1" y="35" />
  <comment>
 maximalni pocet zarizeni typu Inverter   </comment>
</inVariable>
<inVariable name="STRINGBOX_COUNT" type="USINT" id="17">
  <position x="1" y="41" />
  <comment>
 maximalni pocet zarizeni typu StringBox  </comment>
</inVariable>
<inVariable name="BATTERY_COUNT" type="USINT" id="18">
  <position x="1" y="47" />
  <comment>
 maximalni pocet zarizeni typu Battery  </comment>
</inVariable>
<inVariable name="METER_COUNT" type="USINT" id="19">
  <position x="1" y="53" />
  <comment>
 maximalni pocet zarizeni typu Meter  </comment>
</inVariable>
<outVariable name="DeviceTypeCount" type="TDeviceTypeCount" id="20" order="3">
  <position x="62" y="26" />
  <connection refid="6" name="DevTypeCount">
    <position x="63" y="27" />
    <position x="62" y="27" />
    <position x="62" y="27" />
    <position x="61" y="27" />
  </connection>
</outVariable>
<inVariable name="ADR(DeviceInfo)" type="" id="21">
  <position x="1" y="26" />
</inVariable>
<inVariable name="ADR(DeviceInfo)" type="" id="22">
  <position x="90" y="22" />
</inVariable>
<node id="23">
  <position x="33" y="17" />
  <connection refid="8">
    <position x="33" y="17" />
    <position x="17" y="17" />
    <position x="17" y="18" />
    <position x="10" y="18" />
  </connection>
</node>
<node id="24">
  <position x="37" y="21" />
  <connection refid="10">
    <position x="37" y="21" />
    <position x="19" y="21" />
    <position x="19" y="24" />
    <position x="5" y="24" />
  </connection>
</node>
<node id="25">
  <position x="35" y="19" />
  <connection refid="9">
    <position x="35" y="19" />
    <position x="17" y="19" />
    <position x="17" y="21" />
    <position x="9" y="21" />
  </connection>
</node>
<block name="fb_SMReadStuderMiBData" instance="smMiB" id="26" height="16" width="22" line="44" order="11">
  <position x="102" y="32" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="37" name="EQ">
        <position x="102" y="35" />
        <position x="101" y="35" />
        <position x="101" y="33" />
        <position x="100" y="33" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="31">
        <position x="102" y="37" />
        <position x="88" y="37" />
        <position x="88" y="17" />
        <position x="88" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="32">
        <position x="102" y="39" />
        <position x="87" y="39" />
        <position x="87" y="19" />
        <position x="87" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="33">
        <position x="102" y="41" />
        <position x="86" y="41" />
        <position x="86" y="21" />
        <position x="86" y="21" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="27">
        <position x="102" y="43" />
        <position x="97" y="43" />
        <position x="97" y="43" />
        <position x="94" y="43" />
      </connection>
    <comment>pointer to array of blocks obtained with fb_ReadDeviceInfo</comment>
    </variable>
    <variable name="DevMiBPtr" type="PTR_TO TDeviceMiB">
      <connection refid="28">
        <position x="102" y="45" />
        <position x="101" y="45" />
        <position x="101" y="46" />
        <position x="93" y="46" />
      </connection>
    <comment>pointer to array of devices which this fb will fill</comment>
    </variable>
    <variable name="devCount" type="USINT">
      <connection refid="58">
        <position x="102" y="47" />
        <position x="101" y="47" />
        <position x="101" y="48" />
        <position x="78" y="48" />
        <position x="78" y="25" />
        <position x="78" y="25" />
      </connection>
    <comment>number of detected devices</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
    <variable name="DevMiBTypeCount" type="TDeviceMiBTypeCount">
    <comment>structure with count of each device type</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="ADR(DeviceInfo)" type="" id="27">
  <position x="81" y="42" />
</inVariable>
<inVariable name="ADR(DeviceMiB)" type="" id="28">
  <position x="81" y="45" />
</inVariable>
<block name="MOVE" instance="" function="true" hiddenPins="true" operator="true" special="1" id="29" height="6" width="7" line="21" order="4">
  <position x="67" y="10" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="6" name="done">
        <position x="67" y="13" />
        <position x="62" y="13" />
        <position x="62" y="15" />
        <position x="61" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="34">
        <position x="67" y="15" />
        <position x="66" y="15" />
        <position x="66" y="15" />
        <position x="65" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="MOVE" type="ANY">
    </variable>
  </outVariables>
</block>
<block name="EQ" instance="" function="true" hiddenPins="true" operator="true" id="30" height="4" width="3" line="4" order="1">
  <position x="25" y="12" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="47">
        <position x="25" y="13" />
        <position x="17" y="13" />
        <position x="17" y="15" />
        <position x="6" y="15" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="7">
        <position x="25" y="15" />
        <position x="24" y="15" />
        <position x="24" y="15" />
        <position x="22" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="EQ" type="BOOL">
    <comment>Equality
  returns true if IN1 = IN2
</comment>
    </variable>
  </outVariables>
</block>
<node id="31">
  <position x="88" y="17" />
  <connection refid="23">
    <position x="88" y="17" />
    <position x="88" y="17" />
    <position x="88" y="6" />
    <position x="33" y="6" />
    <position x="33" y="17" />
    <position x="33" y="17" />
  </connection>
</node>
<node id="32">
  <position x="87" y="19" />
  <connection refid="25">
    <position x="87" y="19" />
    <position x="87" y="19" />
    <position x="87" y="7" />
    <position x="35" y="7" />
    <position x="35" y="19" />
    <position x="35" y="19" />
  </connection>
</node>
<node id="33">
  <position x="86" y="21" />
  <connection refid="24">
    <position x="86" y="21" />
    <position x="86" y="21" />
    <position x="86" y="8" />
    <position x="37" y="8" />
    <position x="37" y="21" />
    <position x="37" y="21" />
  </connection>
</node>
<inVariable name="1" type="" id="34">
  <position x="63" y="14" />
</inVariable>
<block name="EQ" instance="" function="true" hiddenPins="true" operator="true" id="35" height="4" width="3" line="26" order="6">
  <position x="97" y="12" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="48">
        <position x="97" y="13" />
        <position x="96" y="13" />
        <position x="96" y="12" />
        <position x="94" y="12" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="36">
        <position x="97" y="15" />
        <position x="95" y="15" />
        <position x="95" y="15" />
        <position x="91" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="EQ" type="BOOL">
    <comment>Equality
  returns true if IN1 = IN2
</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="1" type="" id="36">
  <position x="89" y="14" />
</inVariable>
<block name="EQ" instance="" function="true" hiddenPins="true" operator="true" id="37" height="4" width="3" line="42" order="10">
  <position x="97" y="32" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="54">
        <position x="97" y="33" />
        <position x="96" y="33" />
        <position x="96" y="32" />
        <position x="94" y="32" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="42">
        <position x="97" y="35" />
        <position x="94" y="35" />
        <position x="94" y="35" />
        <position x="91" y="35" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="EQ" type="BOOL">
    <comment>Equality
  returns true if IN1 = IN2
</comment>
    </variable>
  </outVariables>
</block>
<block name="EQ" instance="" function="true" hiddenPins="true" operator="true" id="38" height="4" width="3" line="56" order="14">
  <position x="97" y="52" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="52">
        <position x="97" y="53" />
        <position x="96" y="53" />
        <position x="96" y="52" />
        <position x="94" y="52" />
      </connection>
    </variable>
    <variable name="IN2" type="ANY">
      <connection refid="45">
        <position x="97" y="55" />
        <position x="92" y="55" />
        <position x="92" y="55" />
        <position x="91" y="55" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="EQ" type="BOOL">
    <comment>Equality
  returns true if IN1 = IN2
</comment>
    </variable>
  </outVariables>
</block>
<block name="MOVE" instance="" function="true" hiddenPins="true" operator="true" special="1" id="39" height="6" width="7" line="37" order="8">
  <position x="131" y="12" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="2" name="done">
        <position x="131" y="15" />
        <position x="121" y="15" />
        <position x="121" y="15" />
        <position x="120" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="43">
        <position x="131" y="17" />
        <position x="130" y="17" />
        <position x="130" y="17" />
        <position x="129" y="17" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="MOVE" type="ANY">
    </variable>
  </outVariables>
</block>
<block name="MOVE" instance="" function="true" hiddenPins="true" operator="true" special="1" id="40" height="6" width="7" line="51" order="12">
  <position x="131" y="32" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="26" name="done">
        <position x="131" y="35" />
        <position x="125" y="35" />
        <position x="125" y="35" />
        <position x="124" y="35" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="44">
        <position x="131" y="37" />
        <position x="130" y="37" />
        <position x="130" y="37" />
        <position x="129" y="37" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="MOVE" type="ANY">
    </variable>
  </outVariables>
</block>
<block name="MOVE" instance="" function="true" hiddenPins="true" operator="true" special="1" id="41" height="6" width="7" line="67" order="17">
  <position x="131" y="52" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="3" name="Q">
        <position x="131" y="55" />
        <position x="118" y="55" />
        <position x="118" y="55" />
        <position x="116" y="55" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="46">
        <position x="131" y="57" />
        <position x="130" y="57" />
        <position x="130" y="57" />
        <position x="129" y="57" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="MOVE" type="ANY">
    </variable>
  </outVariables>
</block>
<inVariable name="2" type="" id="42">
  <position x="89" y="34" />
</inVariable>
<inVariable name="2" type="" id="43">
  <position x="127" y="16" />
</inVariable>
<inVariable name="3" type="" id="44">
  <position x="127" y="36" />
</inVariable>
<inVariable name="3" type="" id="45">
  <position x="89" y="54" />
</inVariable>
<inVariable name="1" type="" id="46">
  <position x="127" y="56" />
</inVariable>
<inVariable name="state" type="USINT" id="47">
  <position x="1" y="14" />
  <comment>
stav automatu  </comment>
</inVariable>
<inVariable name="state" type="USINT" id="48">
  <position x="89" y="11" />
  <comment>
stav automatu  </comment>
</inVariable>
<outVariable name="next_state" type="USINT" id="49" order="9">
  <position x="139" y="16" />
  <connection refid="39" name="MOVE">
    <position x="140" y="17" />
    <position x="139" y="17" />
    <position x="139" y="17" />
    <position x="138" y="17" />
  </connection>
</outVariable>
<outVariable name="next_state" type="USINT" id="50" order="13">
  <position x="139" y="36" />
  <connection refid="40" name="MOVE">
    <position x="140" y="37" />
    <position x="139" y="37" />
    <position x="139" y="37" />
    <position x="138" y="37" />
  </connection>
</outVariable>
<outVariable name="next_state" type="USINT" id="51" order="18">
  <position x="139" y="56" />
  <connection refid="41" name="MOVE">
    <position x="140" y="57" />
    <position x="139" y="57" />
    <position x="139" y="57" />
    <position x="138" y="57" />
  </connection>
</outVariable>
<inVariable name="state" type="USINT" id="52">
  <position x="89" y="51" />
  <comment>
stav automatu  </comment>
</inVariable>
<outVariable name="next_state" type="USINT" id="53" order="5">
  <position x="75" y="14" />
  <connection refid="29" name="MOVE">
    <position x="76" y="15" />
    <position x="75" y="15" />
    <position x="75" y="15" />
    <position x="74" y="15" />
  </connection>
</outVariable>
<inVariable name="state" type="USINT" id="54">
  <position x="89" y="31" />
  <comment>
stav automatu  </comment>
</inVariable>
<block name="MOVE" instance="" function="true" hiddenPins="true" operator="true" special="1" id="55" height="2" width="5" line="71" order="19">
  <position x="96" y="60" />
  <inVariables>
    <variable name="IN1" type="ANY">
      <connection refid="56">
        <position x="96" y="61" />
        <position x="88" y="61" />
        <position x="88" y="61" />
        <position x="87" y="61" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="MOVE" type="ANY">
    </variable>
  </outVariables>
</block>
<inVariable name="next_state" type="USINT" id="56">
  <position x="78" y="60" />
</inVariable>
<outVariable name="state" type="USINT" id="57" order="20">
  <position x="109" y="60" />
  <comment>
stav automatu  </comment>
  <connection refid="55" name="MOVE">
    <position x="110" y="61" />
    <position x="102" y="61" />
    <position x="102" y="61" />
    <position x="101" y="61" />
  </connection>
</outVariable>
<node id="58">
  <position x="78" y="25" />
  <connection refid="6" name="devCount">
    <position x="78" y="25" />
    <position x="65" y="25" />
    <position x="65" y="25" />
    <position x="61" y="25" />
  </connection>
</node>
</fbd>
{/NOCODE}
//LVD
VAR
END_VAR

//TVD
VAR_TEMP
(* 343	*)	_Nod_Tmp_10	:	STRING[80];
(* 361	*)	_Nod_Tmp_9	:	UINT;
(* 352	*)	_Nod_Tmp_8	:	BOOL;
(* 843	*)	_Nod_Tmp_7	:	USINT;
END_VAR

//NC
//N001
(* 501	*)	LD 	state
(* 509	*)	EQ 	0
(* 127	*)	ST 	smInit.enable
(* 284	*)	LD 	IP_Address
(* 343	*)	ST	_Nod_Tmp_10
(* 287	*)	LD 	chanCode
(* 361	*)	ST	_Nod_Tmp_9
(* 290	*)	LD 	tcp
(* 352	*)	ST	_Nod_Tmp_8
(* 127	*)	CAL	smInit(ip:=_Nod_Tmp_10, chanCode:=_Nod_Tmp_9, tcp:=_Nod_Tmp_8, DevInfoPtr:=ADR(DeviceInfo), DevInfoSize:=DEVICE_COUNT, InverterPtr:=ADR(Inverter), InverterCount:=INVERTER_COUNT, StringBoxPtr:=ADR(StringBox), StringBoxCount:=STRINGBOX_COUNT, BatteryPtr:=ADR(Battery), BatteryCount:=BATTERY_COUNT, MeterPtr:=ADR(Meter), MeterCount:=METER_COUNT)
(* 127	*)	LD 	smInit.DevTypeCount
(* 328	*)	ST 	DeviceTypeCount
(* 127	*)	LD 	smInit.done
//N002
{CREATE_TEMP=__TmpEn_0}
(* 470	*)	ST	__TmpEn_0
(* 470	*)	LD	__TmpEn_0
(* 470	*)	JMPCN __PouSkip_0_1
(* 484	*)	LD 	1
(* 798	*)	ST 	next_state
			__PouSkip_0_1:
//N001
(* 565	*)	LD 	state
(* 573	*)	EQ 	1
(*   8	*)	ST 	sm.enable
(* 127	*)	LD 	smInit.devCount
(* 843	*)	ST	_Nod_Tmp_7
(*   8	*)	CAL	sm(ip:=_Nod_Tmp_10, chanCode:=_Nod_Tmp_9, tcp:=_Nod_Tmp_8, DevInfoPtr:=ADR(DeviceInfo), devCount:=_Nod_Tmp_7)
(*   8	*)	LD 	sm.done
//N003
{CREATE_TEMP=__TmpEn_1}
(* 652	*)	ST	__TmpEn_1
(* 652	*)	LD	__TmpEn_1
(* 652	*)	JMPCN __PouSkip_1_2
(* 666	*)	LD 	2
(* 766	*)	ST 	next_state
			__PouSkip_1_2:
//N001
(* 596	*)	LD 	state
(* 604	*)	EQ 	2
(* 370	*)	ST 	smMiB.enable
(* 370	*)	CAL	smMiB(ip:=_Nod_Tmp_10, chanCode:=_Nod_Tmp_9, tcp:=_Nod_Tmp_8, DevInfoPtr:=ADR(DeviceInfo), DevMiBPtr:=ADR(DeviceMiB), devCount:=_Nod_Tmp_7)
(* 370	*)	LD 	smMiB.done
//N004
{CREATE_TEMP=__TmpEn_2}
(* 683	*)	ST	__TmpEn_2
(* 683	*)	LD	__TmpEn_2
(* 683	*)	JMPCN __PouSkip_2_3
(* 697	*)	LD 	3
(* 775	*)	ST 	next_state
			__PouSkip_2_3:
//N005
(* 624	*)	LD 	state
(* 632	*)	EQ 	3
(*  84	*)	ST 	timer.IN
(*  84	*)	CAL	timer(PT:=PERIOD_TIME)
(*  84	*)	LD 	timer.ET
(* 115	*)	ST 	timer_ET
(*  84	*)	LD 	timer.Q
//N006
{CREATE_TEMP=__TmpEn_3}
(* 714	*)	ST	__TmpEn_3
(* 714	*)	LD	__TmpEn_3
(* 714	*)	JMPCN __PouSkip_3_4
(* 728	*)	LD 	1
(* 784	*)	ST 	next_state
			__PouSkip_3_4:
//N007
(* 816	*)	LD 	next_state
(* 832	*)	ST 	state

END_PROGRAM
