PROGRAM prgMain
  VAR CONSTANT
    IP_Address      : STRING := '192.168.1.125:502';
    chanCode        : UINT   := ETH1_uni0;
    tcp             : BOOL   := true;

    slaveID : USINT := 1; (*logicke id zarizeni v SM2-MU, kteremu nastavujeme vykon
                          (zde musi byt Xtender, protoze pracujeme s parametrem 1297)*)
    DEVICE_COUNT : USINT := 7;
  END_VAR

  VAR_INPUT
  END_VAR
  VAR_OUTPUT
  END_VAR
  VAR
    smInit : fb_SMInit;
    smInit_enable : BOOL := true;
    smFini : fb_SMFini;
    par_SR : SR;
    DeviceInfo : ARRAY [1..DEVICE_COUNT]    OF TDeviceBlockInfo; (*Informace o blocich v jednotlivych zarizenich*)
    smPar : fb_SMReadWriteParameter;
    par : TParams := (id := 1297, pType := PARAM_FLOAT,(* value := 0, *) cmd := PARAM_READ);
  END_VAR
  VAR_TEMP
  END_VAR
{NOCODE}
<?xml version="1.0" encoding="windows-1250" ?>
<?xml-stylesheet type="text/xsl" href="pokus.xsl" version="1.1"?>
<fbd version="1.1">
<comment id="1" height="3" width="12">
  <position x="3" y="5" />
Schema comment
</comment>
<block name="fb_SMInit" instance="smInit" id="2" height="30" width="20" line="9" order="1">
  <position x="41" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="3">
        <position x="41" y="15" />
        <position x="18" y="15" />
        <position x="18" y="15" />
        <position x="11" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="17">
        <position x="41" y="17" />
        <position x="34" y="17" />
        <position x="34" y="17" />
        <position x="33" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="19">
        <position x="41" y="19" />
        <position x="36" y="19" />
        <position x="36" y="19" />
        <position x="35" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="18">
        <position x="41" y="21" />
        <position x="38" y="21" />
        <position x="38" y="21" />
        <position x="37" y="21" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="16">
        <position x="41" y="23" />
        <position x="21" y="23" />
        <position x="21" y="27" />
        <position x="13" y="27" />
      </connection>
    <comment>pointer to array start</comment>
    </variable>
    <variable name="DevInfoSize" type="USINT">
      <connection refid="7">
        <position x="41" y="25" />
        <position x="23" y="25" />
        <position x="23" y="30" />
        <position x="13" y="30" />
      </connection>
    <comment>max. number of devices (array size)</comment>
    </variable>
    <variable name="InverterPtr" type="PTR_TO TInverter">
      <connection refid="8">
        <position x="41" y="27" />
        <position x="25" y="27" />
        <position x="25" y="33" />
        <position x="3" y="33" />
      </connection>
    <comment>Pointer to array of Inverter structures</comment>
    </variable>
    <variable name="InverterCount" type="USINT">
      <connection refid="12">
        <position x="41" y="29" />
        <position x="27" y="29" />
        <position x="27" y="36" />
        <position x="3" y="36" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="StringBoxPtr" type="PTR_TO TStringBox">
      <connection refid="9">
        <position x="41" y="31" />
        <position x="29" y="31" />
        <position x="29" y="39" />
        <position x="3" y="39" />
      </connection>
    <comment>Pointer to array of StringBox structures</comment>
    </variable>
    <variable name="StringBoxCount" type="USINT">
      <connection refid="13">
        <position x="41" y="33" />
        <position x="31" y="33" />
        <position x="31" y="42" />
        <position x="3" y="42" />
      </connection>
    <comment>max. number of Inverters (array size)</comment>
    </variable>
    <variable name="BatteryPtr" type="PTR_TO TBattery">
      <connection refid="10">
        <position x="41" y="35" />
        <position x="33" y="35" />
        <position x="33" y="45" />
        <position x="3" y="45" />
      </connection>
    <comment>Pointer to array of Battery structures</comment>
    </variable>
    <variable name="BatteryCount" type="USINT">
      <connection refid="14">
        <position x="41" y="37" />
        <position x="35" y="37" />
        <position x="35" y="48" />
        <position x="3" y="48" />
      </connection>
    <comment>max. number of Batteries (array size)</comment>
    </variable>
    <variable name="MeterPtr" type="PTR_TO TMeter">
      <connection refid="11">
        <position x="41" y="39" />
        <position x="37" y="39" />
        <position x="37" y="51" />
        <position x="3" y="51" />
      </connection>
    <comment>Pointer to array of Meter structures</comment>
    </variable>
    <variable name="MeterCount" type="USINT">
      <connection refid="15">
        <position x="41" y="41" />
        <position x="39" y="41" />
        <position x="39" y="54" />
        <position x="3" y="54" />
      </connection>
    <comment>max. number of Meters (array size)</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
    <variable name="errTxt" type="STRING[80]">
    <comment>error report</comment>
    </variable>
    <variable name="devCount" type="USINT">
    <comment>number of devices in the SM2-MU gateway</comment>
    </variable>
    <variable name="DevTypeCount" type="TDeviceTypeCount">
    <comment>structure with count of each device type</comment>
    </variable>
  </outVariables>
</block>
<inVariable name="smInit_enable" type="BOOL" id="3">
  <position x="1" y="14" />
</inVariable>
<inVariable name="IP_Address" type="STRING" id="4">
  <position x="1" y="17" />
</inVariable>
<inVariable name="chanCode" type="UINT" id="5">
  <position x="1" y="20" />
</inVariable>
<inVariable name="tcp" type="BOOL" id="6">
  <position x="1" y="23" />
</inVariable>
<inVariable name="DEVICE_COUNT" type="USINT" id="7">
  <position x="1" y="29" />
</inVariable>
<inVariable name="0" type="" id="8">
  <position x="1" y="32" />
</inVariable>
<inVariable name="0" type="" id="9">
  <position x="1" y="38" />
</inVariable>
<inVariable name="0" type="" id="10">
  <position x="1" y="44" />
</inVariable>
<inVariable name="0" type="" id="11">
  <position x="0" y="50" />
</inVariable>
<inVariable name="0" type="" id="12">
  <position x="1" y="35" />
  <comment>
 maximalni pocet zarizeni typu Inverter   </comment>
</inVariable>
<inVariable name="0" type="" id="13">
  <position x="0" y="41" />
  <comment>
 maximalni pocet zarizeni typu StringBox  </comment>
</inVariable>
<inVariable name="0" type="" id="14">
  <position x="1" y="47" />
  <comment>
 maximalni pocet zarizeni typu Battery  </comment>
</inVariable>
<inVariable name="0" type="" id="15">
  <position x="1" y="53" />
  <comment>
 maximalni pocet zarizeni typu Meter  </comment>
</inVariable>
<inVariable name="ADR(DeviceInfo)" type="" id="16">
  <position x="1" y="26" />
</inVariable>
<node id="17">
  <position x="33" y="17" />
  <connection refid="4">
    <position x="33" y="17" />
    <position x="17" y="17" />
    <position x="17" y="18" />
    <position x="10" y="18" />
  </connection>
</node>
<node id="18">
  <position x="37" y="21" />
  <connection refid="6">
    <position x="37" y="21" />
    <position x="19" y="21" />
    <position x="19" y="24" />
    <position x="4" y="24" />
  </connection>
</node>
<node id="19">
  <position x="35" y="19" />
  <connection refid="5">
    <position x="35" y="19" />
    <position x="17" y="19" />
    <position x="17" y="21" />
    <position x="9" y="21" />
  </connection>
</node>
<block name="SR" instance="par_SR" id="41" height="6" width="6" line="10" order="2">
  <position x="72" y="12" />
  <inVariables>
    <variable name="S1" type="BOOL">
      <connection refid="2" name="done">
        <position x="72" y="15" />
        <position x="66" y="15" />
        <position x="66" y="15" />
        <position x="61" y="15" />
      </connection>
    </variable>
    <variable name="R" type="BOOL">
    </variable>
  </inVariables>
  <outVariables>
    <variable name="Q1" type="BOOL">
    </variable>
  </outVariables>
</block>
<block name="fb_SMReadWriteParameter" instance="smPar" id="42" height="14" width="19" line="11" order="3">
  <position x="90" y="12" />
  <inVariables>
    <variable name="enable" type="BOOL">
      <connection refid="41" name="Q1">
        <position x="90" y="15" />
        <position x="80" y="15" />
        <position x="80" y="15" />
        <position x="78" y="15" />
      </connection>
    <comment>if enable=0, block is disabled, start with rising edge</comment>
    </variable>
    <variable name="ip" type="STRING[80]">
      <connection refid="17">
        <position x="90" y="17" />
        <position x="89" y="17" />
        <position x="89" y="6" />
        <position x="33" y="6" />
        <position x="33" y="17" />
        <position x="33" y="17" />
      </connection>
    <comment>SM2-MU gateway IP address</comment>
    </variable>
    <variable name="chanCode" type="UINT">
      <connection refid="19">
        <position x="90" y="19" />
        <position x="87" y="19" />
        <position x="87" y="7" />
        <position x="35" y="7" />
        <position x="35" y="19" />
        <position x="35" y="19" />
      </connection>
    <comment>communication channel number</comment>
    </variable>
    <variable name="tcp" type="BOOL">
      <connection refid="57">
        <position x="90" y="21" />
        <position x="85" y="21" />
        <position x="85" y="8" />
        <position x="85" y="8" />
      </connection>
    <comment>protocol type - TRUE = TCP, FALSE = UDP</comment>
    </variable>
    <variable name="DevInfoPtr" type="PTR_TO TDeviceBlockInfo">
      <connection refid="58">
        <position x="90" y="23" />
        <position x="84" y="23" />
        <position x="84" y="23" />
        <position x="83" y="23" />
      </connection>
    <comment>pointer to array item (contains also device address)</comment>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="done" type="BOOL">
    <comment>block finished</comment>
    </variable>
    <variable name="busy" type="BOOL">
    <comment>block is still running</comment>
    </variable>
    <variable name="err" type="BOOL">
    <comment>block ended with error</comment>
    </variable>
    <variable name="errCode" type="USINT">
    <comment>error code</comment>
    </variable>
  </outVariables>
  <inOutVariables>
    <variable name="params" type="TParams">
      <connection refid="60">
        <position x="90" y="25" />
        <position x="89" y="25" />
        <position x="89" y="26" />
        <position x="69" y="26" />
      </connection>
    <comment>Structure of read/write Modbus Sunspec parameter block</comment>
    </variable>
  </inOutVariables>
</block>
<block name="fb_SMFini" instance="smFini" id="43" height="6" width="11" line="17" order="4">
  <position x="114" y="12" />
  <inVariables>
    <variable name="__EN" type="BOOL" eneno="true">
      <connection refid="42" name="done">
        <position x="114" y="15" />
        <position x="110" y="15" />
        <position x="110" y="15" />
        <position x="109" y="15" />
      </connection>
    </variable>
  </inVariables>
  <outVariables>
    <variable name="__ENO" type="BOOL" eneno="true">
    </variable>
  </outVariables>
  <inVariables>
    <variable name="tcp" type="BOOL">
      <connection refid="57">
        <position x="114" y="17" />
        <position x="112" y="17" />
        <position x="112" y="8" />
        <position x="85" y="8" />
      </connection>
    <comment>protocol type</comment>
    </variable>
  </inVariables>
</block>
<node id="57">
  <position x="85" y="8" />
  <connection refid="18">
    <position x="85" y="8" />
    <position x="37" y="8" />
    <position x="37" y="21" />
    <position x="37" y="21" />
  </connection>
</node>
<inVariable name="ADR(DeviceInfo[slaveID])" type="" id="58">
  <position x="65" y="22" />
</inVariable>
<inVariable name="par" type="TParams" id="60">
  <position x="65" y="25" />
</inVariable>
</fbd>
{/NOCODE}
//LVD
VAR
END_VAR

//TVD
VAR_TEMP
(* 212	*)	_Nod_Tmp_3	:	STRING[80];
(* 230	*)	_Nod_Tmp_2	:	UINT;
(* 221	*)	_Nod_Tmp_1	:	BOOL;
END_VAR

//NC
//N000
(* 165	*)	LD 	IP_Address
(* 212	*)	ST	_Nod_Tmp_3
(* 168	*)	LD 	chanCode
(* 230	*)	ST	_Nod_Tmp_2
(* 171	*)	LD 	tcp
(* 221	*)	ST	_Nod_Tmp_1
(*   8	*)	CAL	smInit(enable:=smInit_enable, ip:=_Nod_Tmp_3, chanCode:=_Nod_Tmp_2, tcp:=_Nod_Tmp_1, DevInfoPtr:=ADR(DeviceInfo), DevInfoSize:=DEVICE_COUNT, InverterPtr:=0, InverterCount:=0, StringBoxPtr:=0, StringBoxCount:=0, BatteryPtr:=0, BatteryCount:=0, MeterPtr:=0, MeterCount:=0)
(* 239	*)	CAL	par_SR(S1:=smInit.done)
(* 258	*)	CAL	smPar(enable:=par_SR.Q1, ip:=_Nod_Tmp_3, chanCode:=_Nod_Tmp_2, tcp:=_Nod_Tmp_1, DevInfoPtr:=ADR(DeviceInfo[slaveID]), params:=void(par))
(* 258	*)	LD 	smPar.done
{CREATE_TEMP=__TmpEn_0}
(* 341	*)	ST	__TmpEn_0
(* 341	*)	LD	__TmpEn_0
(* 341	*)	JMPCN __PouSkip_0_1
(* 337	*)	CAL	smFini(tcp:=_Nod_Tmp_1)
			__PouSkip_0_1:

END_PROGRAM
